<template>
  <el-dialog :title="titleValue" width="1400px" :model-value="modelValue" append-to-body @close="closed">
    <div>
      <el-form :model="listQuery" class="mosty-from-wrap" :inline="true">
        <el-form-item label="线索名称">
          <el-input placeholder="请输入线索名称" v-model="listQuery.xsMc" clearable ></el-input>
        </el-form-item>
        <el-form-item>
          <el-button type="success" @click="handleFilter">查询</el-button>
          <el-button type="info" @click="reset()"> 重置 </el-button>
        </el-form-item>
      </el-form>
      <div class="tabBox" :class="props.Single ? 'tabBoxRadio' : ''" style="margin-top: 0px">
        <el-table ref="multipleUserRef" v-loading="loading" :key="keyTabel" @selection-change="handleSelectionChange" :data="tableData" border :row-key="keyid" style="width: 100%" height="450">
          <el-table-column type="selection" width="55" :reserve-selection="true"/>
          <el-table-column prop="xsBh" align="center" label="线索编号"/>
          <el-table-column prop="xsMc" align="center" label="线索名称"/>
          <el-table-column prop="xlLx" align="center" label="线索类型">
            <template #default="{ row }">
              <DictTag :tag="false"  :value="row.xlLx" :options="D_GS_XS_LX" />
            </template>
          </el-table-column>
          <el-table-column prop="qbLy" align="center" label="线索来源">
            <template #default="{ row }">
              <DictTag :value="row.qbLy" :tag="false" :options="D_GS_XS_LY" />
            </template>
          </el-table-column>
          <el-table-column prop="xsNr" align="center" label="线索内容"/>
        </el-table>
      </div>
      <div class="fenye" :style="{ top: tableHeight + 'px' }">
        <el-pagination
          class="pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="listQuery.pageCurrent"
          :page-sizes="[10, 20, 50, 100]"
          :page-size="listQuery.pageSize"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
        ></el-pagination>
      </div>
    </div>
    <template #footer>
      <div class="dialog-footer">
        <el-button @click="closed">取消</el-button>
        <el-button type="primary" @click="onComfirm">确认</el-button>
      </div>
    </template>
  </el-dialog>
  
</template>

<script setup>

import { qcckGet} from "@/api/qcckApi.js";
import { defineProps, ref ,getCurrentInstance, watch} from "vue";
const { proxy } = getCurrentInstance();
const { D_GS_XS_LX,D_GS_XS_LY } = proxy.$dict("D_GS_XS_LX","D_GS_XS_LY"); //获取字典数据
const props = defineProps({
  modelValue: {
    type: Boolean,
    default:false
  },
  titleValue: {
    type: String,
    default: "选择线索"
  },
  LeaderType: {
    type: String,
    default: ""
  },
  //是否单选
  Single: {
    type: Boolean,
    default: true
  },
  roleIds: {
    type: Array,
    default: []
  }
});
const loading = ref(false)
const total = ref(0);
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 20
});

const multipleUserRef = ref(null);
const multipleSelectionUser = ref([]);
const tableData = ref([]);
const emits = defineEmits(["update:modelValue", "choosed"]);
const keyTabel = ref(0)
const keyid = (row) => {
  return row.id;
};

const closed = () => {
  emits("update:modelValue", false);
};
const reset = () => {
  listQuery.value = {  pageCurrent: 1, pageSize: 20, };
  getListData();
};


// 为用户分配角色
const onComfirm = () => {
  const userList = multipleSelectionUser.value;
  let list = [];
  let listId = [];
  userList.forEach((val) => {
    if (listId.indexOf(val.id) == -1) {
      list.push(val);
      listId.push(val.id);
    }
  });
  emits("choosed", list);
  closed();
};
/**
 * pageSize 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.pageSize = currentSize;
  getListData();
};
/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.pageCurrent = currentPage;
  getListData();
};
const getListData = () => {
  keyTabel.value++
  const params = {...listQuery.value}
  loading.value = true;
  qcckGet(params,'/mosty-gsxt/qbcj/selectPage').then(res=>{
    loading.value = false;
    tableData.value = res.records || [];
    total.value = res.total;
    multipleUser();
  }).catch(()=>{
    loading.value = false;
  })
};

//列表回显
function multipleUser() {
  tableData.value.forEach((item) => {
     multipleUserRef.value.toggleRowSelection(item, false);
    if (props.roleIds.some((id) => id == item.id)) {
      multipleUserRef.value.toggleRowSelection(item, true);
    }
  });
}

const handleFilter = () => {
  listQuery.value.pageCurrent = 1;
  getListData();
};

const handleSelectionChange = (val) => {
  if (props.Single) {
    if (val.length > 1) {
      let del_row = val.shift();
      multipleUserRef.value.toggleRowSelection(del_row, false);
    }
    multipleSelectionUser.value = val;
  } else {
    multipleSelectionUser.value = val;
  }
};

watch(()=>props.modelValue,val=>{
  if(val) handleFilter();
},{immediate:true})

</script>

<style lang="scss" scoped>
@import "@/assets/css/layout.scss";
@import "@/assets/css/element-plus.scss";
</style>
<style>
.tabBoxRadio .el-checkbox__inner {
  border-radius: 50% !important;
}
.tabBoxRadio .el-table__header-wrapper .el-checkbox {
  display: none;
}

</style>
